#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <sys/stat.h>
#include <pwd.h>
#include <grp.h>
#include <time.h>
#include <locale.h>
#include <langinfo.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>

#define BUF_MAX 255

struct dnode {
	char		*file;
	char		*fullname;
	struct stat	st;
	struct dnode	*next;
};

struct dnode *dnode_list;

size_t dnode_size;
size_t dnode_used;

 int numericproc(char *dirname)
{
	char* nomer = "0123456789";
	
	int sum=0;
	int i,j;

	int len = strlen(dirname);

	for(i=0;i<10;i++){

		for(j=0;j<len;j++){

			if (dirname[j]==nomer[i]){

				sum++;

				continue;
			}
		}
	}

	if (sum == len){

		return 1;
	}else{
		return 0;
	}
}

int main(int argc, char *argv[])
{
	char cwd[256];
	char perm[11];
	DIR *dirh;
	char dir[BUF_MAX+1];
	struct dirent  *dp;
	struct stat     statbuf;
	struct passwd  *pwd;
	struct group   *grp;
	struct tm      *tm;
	char            datestring[256];

	
	if (argc >= 2) {
		if (*argv[1] == '/') {
			strncpy(dir, argv[1], sizeof(dir));
			dir[BUF_MAX] = 0;
		} else {
			if (getcwd(cwd, sizeof(cwd)) != NULL) {
				snprintf(dir, sizeof(dir), "%s/%s", cwd, argv[1]);
			} else {
				fprintf(stderr, "Can't get curent dir: %s\n", strerror(errno));
				exit(1);
			}
		}
	} else {
		if (getcwd(dir, sizeof(dir)) == NULL) {
			fprintf(stderr, "Can't get curent dir: %s\n", strerror(errno));
			return(1);
		}
	}
	
	dirh = opendir("/proc");

	if (dirh == NULL) {
		fprintf(stderr, "Can't get open directory '%s': %s\n", dir, strerror(errno));
		exit(1);
	}

	while ((dp = readdir(dirh)) != NULL) {

		struct dnode *np;
		char fullname[256];

		snprintf(fullname, sizeof(fullname), "%s/%s", dir, dp->d_name);

		if (stat(fullname, &statbuf) == 0) {

			np = malloc(sizeof(*np));
			if (np == NULL) {
			}
			memset(np, 0, sizeof(*np));

			np->st = statbuf;
			
			np->fullname = strdup(fullname);
			if (np->fullname==NULL) {
			
				fprintf(stderr,"out of memory :%s\n");
				return 1;}	
				
				np->file = basename(np->fullname);
			

				np->next = dnode_list;
				dnode_list = np;
		}

		char* pr = dp->d_name;



		//strcat(pr,"/cmdline");
//		FILE *f;
//		f = fopen(cmdline);
//		string str;
//		fscanf(f,"%d",&str);
//		string user;
//		fscanf(f,"%d",&user);
//		char*str="128";
//		int d;
//		sscanf(str,"%d",&d);
		//printf("%d\n", d);
	//	int getinfo(char *procname){
		char *ss = malloc(*ss); 
		char str[PATH_MAX];
		char str2[PATH_MAX];
		char *sss = malloc(*sss);
		
		if (numericproc(pr)) {	
			int pid;
			pid = atoi(pr);
			snprintf(str, sizeof(str), "/proc/%s/cmdline", pr);
			
			FILE *f;
			f = fopen(str, "r");
			
			if (f != NULL) {
				fread(ss, 1, PATH_MAX, f);
				ss[PATH_MAX] = '\0';
			}

			fclose(f);
			
			snprintf(str2, sizeof(str2), "/proc/%s/stat", pr);
			
			FILE *ff;
			
			ff = fopen(str2, "r");
			
			char c;
			fscanf(ff, "%c",&c);
 			while (c != '(') {
				fscanf(ff, "%c",&c);
			}
			fscanf(ff, "%c",&c);
 			
 			int i = 0;
			
			sss[i++] = '[';
			do {
				sss[i++] = c;
 
				fscanf(ff, "%c",&c);
			} while (c != ')');	
				
			fscanf(ff, "%c",&c);
			sss[i++] = ']';
			sss[i] = '\0';


			if (ss[0] == NULL)
				ss = sss;
			
			fclose(ff);

			printf("%s      %s\n", pr, ss);
		}
	}

	closedir(dirh);			
	return EXIT_SUCCESS;
}